#!/usr/bin/python

#[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
##################################}@{
#
#	EMI(C)2003-2004 FLB STUDIO 2K4
#	Autor : Felix Le Blanc Mtl
#
##################################}@{
#
#	Class library for Emi:
#
#		Class SCREWS : Draw Panel Screws
#		Class CAPBOX : Draw Panel Corners
#		Class FRONTBOX : Draw Front Panel
#		Class FRONTBOX : Draw Front Panel
#		Class ROLL_BUTTON : Roll Button Constructor
#		Class STRING_WINDOW : Led Window Constroctor
#		Class BOX_SPACER : Shade/hole/fan or Spacer Constroctor
#
##################################}@{
#]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

from tkSimpleDialog import *
import sys
from math import *
from COLOR_FADER import *

#CursorStr = [("bottom_tee",0),("double_arrow",1),("left_ptr_watch",2),("right_tee",3),("top_left_corner",4),("X_cursor",5),("center_ptr",6),("draft_large",7),("left_side",8),("sb_h_double_arrow",9),("top_right_corner",10),("arrow",11),("circle",12),("draft_small",13),("left_tee",14),("sb_right_arrow",15),("top_side",16),("based_arrow_down",17),("cross",18),("draped_box",19),("ll_angle",20),("sb_up_arrow",21),("top_tee",22),("based_arrow_up",23),("cross_reverse",24),("fleur",25),("pencil",26),("sb_v_double_arrow",27),("watch",28),("bottom_left_corner",29),("crosshair",30),("gumby",31),("plus",32),("exchange",33),("xterm",34),("bottom_right_corner",35),("dot",36),("hand2",37),("right_ptr",38),("tcross",39),("bottom_side",40),("dotbox",41),("left_ptr",42),("right_side",43),("top_left_arrow",44)]

class SCREWS(Canvas):
	def __init__(self,master=None,hy=50,side="LEFT"):
		if (side == "LEFT") | (side == "RIGHT"):
			self.side = side
		self.hy = hy
		self.wx = 20
		self.border = 0
		self.screws=[]
		self.screwStep=4
		self.tcolor=RGB2RGB([20,20,20],[60,60,60],self.screwStep)
		self.master = master
		Canvas.__init__(self,master=self.master,width=self.wx,height=self.hy,bg="#202020",border=self.border,highlightthickness=0,relief=RAISED)
		for i in range((int(self.hy/10/2))):
			if i % 2 == 0:
				self.create_oval(5,6+(i*20),15,20+(i*20),fill="#000000",outline="")
			else:
				self.create_oval(5,6+(i*20),15,16+(i*20),fill="#000000",outline="")
		for i in range(self.screwStep):
			color = RGB2STR(self.tcolor[i])
			self.screws.append(self.create_oval(3+i,3+i,16-i,16-i,fill="",outline=color))
			if self.hy>50:
				self.screws.append(self.create_oval(3+i,83+i,16-i,96-i,fill="",outline=color))
			else:
				self.screws.append(self.create_oval(3+i,33+i,16-i,46-i,fill="",outline=color))
		if self.side == "LEFT":
			self.pack(side=LEFT)
		elif self.side == "RIGHT":
			self.pack(side=RIGHT)

class CAPBOX(Canvas):
	def __init__(self,master=None,hy=50,side="LEFT",rgb=[90,90,255]):
		if (side == "LEFT") | (side == "RIGHT"):
			self.side = side
		else:
			print "A correct side value is 'LEFT' or 'RIGHT' DEFAULT is 'LEFT'"
			self.side = "LEFT"

		self.master = master
		self.hy = hy
		self.wx = 18
		self.rgb = rgb
		self.rgbFactor= [int(rgb[0]/10-1),int(rgb[1]/10-1),int(rgb[2]/10-1)]
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.colorTable=RGB2RGB(self.rgb,[0,0,0],10)
		Canvas.__init__(self,master=self.master)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		if self.side == "LEFT":
			self.drawLeft()
			self.pack(side=LEFT)
		elif self.side == "RIGHT":
			self.drawRight()
			self.pack(side=RIGHT)

	def drawLeft(self):
		for i in range(10):
			color = RGB2STR(self.colorTable[i])
			self.create_line(self.wx-9-i,9-i,self.wx-9-i,self.hy-9+i,fill=color)
			self.create_line(self.wx,9-i,9-i,9-i,fill=color)
			self.create_line(9-i,self.hy-9+i,self.wx,self.hy-9+i,fill=color)

	def drawRight(self):
		for i in range(10):
			color = RGB2STR(self.colorTable[i])
   			self.create_line(9+i,9-i,9+i,self.hy-9+i,fill=color)
			self.create_line(0,self.hy-9+i,self.wx-8+i,self.hy-9+i,fill=color)
			self.create_line(0,9-i,self.wx-9+i,9-i,fill=color)

class FRONTBOX(Canvas):
	def __init__(self,master=None,hy=50,width=80,rgb=[90,90,255]):
		self.master = master
		self.hy = hy
		self.wx = width
		self.rgb = rgb
		self.rgbFactor= [int(rgb[0]/10-1),int(rgb[1]/10-1),int(rgb[2]/10-1)]
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.colorTable=RGB2RGB(self.rgb,[0,0,0],10)
		Canvas.__init__(self,master=self.master)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.draw()

	def draw(self):
		for i in range(10):
			color = RGB2STR(self.colorTable[i])
			self.create_line(0,9-i,self.wx,9-i,fill=color)
			self.create_line(0,self.hy-9+i,self.wx,self.hy-9+i,fill=color)
		self.pack(side=LEFT)

class ROLL_BUTTON(Canvas):
	def __init__(self,master=None,rgb=None,capcolor="#FFFFFF",startV=0,endV=100,vector=1.0,CHAINCOM=None,ECATALK=None,EMICOM=None,command=None,BOXCOM=None):
		self.master = master
		self.hy = 30
		self.wx = 30
		self.rgb = rgb
		self.space = 5
		self.capcolor=capcolor
		self.color = RGB2STR((self.rgb[0],self.rgb[1],self.rgb[2]))
		self.colorTable=RGB2RGB(rgb,[0,0,0],self.space)
		self.colorTable2=RGB2RGB([0,0,0],[155,155,155],10)
		self.cap = [0]*10
		self.cursor=None
		self.v=0
		self.topper=None
		self.vclicx=None
		self.vclicy=None
		self.startV = startV
		self.endV=endV
		self.diff = int(self.endV-self.startV)
		self.vector=0.0
		self.CHAINCOM =CHAINCOM
		self.ECATLK=ECATALK
		self.EMICOM=EMICOM
		self.BOXCOM=BOXCOM
		self.command=command
		self.deg=0
		self.center=(self.hy/2)
		Canvas.__init__(self,master=self.master)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.CalculateVector()
		self.drawbasewindow()
		self.SetCursor()
		self.bind("<Button-1>",self.roll)
		self.bind("<ButtonRelease-1>",self.SetLed)
		self.bind("<B1-Motion>",self.roll)
		self.bind("<Enter>",self.CursorOn)
	def CursorOn(self=None,event=None):
		self.configure(cursor="hand2")
	def Degree(self=None,event=None):
		x=event.x
		y=event.y
		SX=x-self.center
		SY=y-self.center
		rad=atan2(SX,SY)
		deg=rad*(180.0/pi)
		deg2=0.0
		if deg < 0.0:
			deg2=180.0-(deg+180.0)
		elif deg > 0.0:
			deg2=360.0-deg
		elif (deg==0.0) and (y>self.center):
			deg2=0.0
		elif (deg==0.0) and (y<self.center):
			deg2=180.0
		#print x,y,deg2
		return deg2
		
	def roll(self=None,event=None):
		self.deg=int(self.Degree(event))
		self.v=int((self.deg)/(360.0/float(self.diff)))
		self.Set(self.v)
		#print self.v

	def Set(self=None,event=None):
		self.v=int(event)
		self.flushCursor()
		if self.command!=None:
			self.command(self.v)
	def simpleSet(self=None,event=None):
		self.v=event
		self.flushCursor()
	def drawbasewindow(self=None,event=None):
		for i in range(self.space):
			color = RGB2STR(self.colorTable[i])
			self.create_oval(i,i,self.wx-i,self.hy-i,outline="",fill=color)
		self.create_line(2,15,28,15,width=2,fill=self.color)
		self.create_line(15,2,16,15,width=2,fill=self.color)
		self.create_line(5,5,25,25,width=1,fill=self.color)
		self.create_line(24,5,5,24,width=1,fill=self.color)
		for i in range(10):
			color = RGB2STR(self.colorTable2[i])
			self.cap[i]=self.create_oval(i+5,i+5,self.wx-i-5,self.hy-i-5,outline="",fill=color)
	def SetCursor(self=None,event=None):
		self.cursor=self.create_arc(3,3,self.wx-3,self.hy-3,start=(240-(self.GetVector()))-15,extent=30,style=PIESLICE,fill="#696969",outline="#AAAAAA")
		self.topper=self.create_oval(12,12,18,18,outline="#000000",fill=self.capcolor)
	def SetLed(self=None,event=None):
		if self.BOXCOM!=None:
			self.BOXCOM(self.v)
	def flushCursor(self=None,event=None):
		self.delete(self.topper)
		self.delete(self.cursor)
		self.SetCursor()
	def GetVector(self=None,event=None):
		if self.diff>300:
			return int(float(self.v)/self.vector)
		if self.diff<300:
			return int(float(self.v)*self.vector)
	def CalculateVector(self=None,event=None):
		if self.diff>300:
			self.vector = float(self.diff)/float(300)
		elif self.diff<300:
			self.vector = float(300)/float(self.diff)
		else:
			self.vector=1.0

class STRING_WINDOW(Canvas):
	def __init__(self,master=None,rgb=[90,90,255],wx=300,hy=30):
		self.master = master
		self.hy = hy
		self.wx = wx
		self.rgb = rgb
		self.space = 4
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.colorTable=RGB2RGB(self.rgb,[0,0,0],10)
		self.v = 0.0
		self.ledstr =""
		self.push = 0
		self.divider = int(self.hy/self.space/2)
		self.fontcolor="#25FFBB"
		self.windowColorTable=RGB2RGB([0,0,0],[35,35,65],(self.wx/2-4))
		self.fontsize=5
		Canvas.__init__(self,master=self.master)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.drawbasewindow()

	def drawbasewindow(self):
		for i in range(self.space):
			color = RGB2STR(self.colorTable[i])
			self.create_line(i,i,self.wx-i,i,fill=color)
			self.create_line(i,self.hy-i,self.wx-i,self.hy-i,fill=color)
			self.create_line(i,i,i,self.hy-i,fill=color)
			self.create_line(self.wx-i,i,self.wx-i,self.hy-i+1,fill=color)
		self.create_rectangle((self.space),(self.space),(self.wx-self.space),(self.hy-self.space),fill="#556955")
		for i in range(len(self.windowColorTable)):
			color = RGB2STR((self.windowColorTable[i]))
			self.create_line(i+6,6,i+6,self.hy-5,fill=color)
			self.create_line(self.wx-i-6,6,self.wx-i-6,self.hy-5,fill=color)
		self.strTxt = self.create_text(self.wx/2,self.hy/2+1,text=self.ledstr,anchor=CENTER,fill=self.fontcolor,font="helvetica 10  bold")
		self.pack(side=LEFT)
	def Set(self=None,event=None):
		if event==None:
			self.delete(self.strTxt)
			self.strTxt = self.create_text(self.wx/2,self.hy/2+1,text=self.ledstr,anchor=CENTER,fill=self.fontcolor,font=("helvetica "+str(self.fontsize)+"  bold"))

		else:
			self.ledstr=event
			self.delete(self.strTxt)
			self.strTxt = self.create_text(self.wx/2,self.hy/2+1,text=self.ledstr,anchor=CENTER,fill=self.fontcolor,font="helvetica 4  bold")
		if self.fontsize<10:
			self.fontsize=self.fontsize+1
			self.after(10,self.Set)
		elif self.fontsize==10:
			self.fontsize=5

class BOX_SPACER(Canvas):
	def __init__(self,master=None,rgb=[90,90,255],wx=300,hy=30,grille=0,shade=1):
		self.master = master
		self.hy = hy
		self.wx = wx
		self.rgb = rgb
		self.space = 4
		self.shade=shade
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		if self.shade==1:
			self.colorTable1=RGB2RGB(self.rgb,RGBGETVERYHIGHLIGHT(self.rgb),(self.wx/2))
		self.grille=grille
		self.hole=(int(self.hy/6))
		if self.grille!=0:
			self.poly = [10,0,13,3,self.wx-3,3,self.wx,0]
			self.colorTable2=RGB2RGB(RGBGETVERYDARKSHADOW(self.rgb),self.rgb,5)

		Canvas.__init__(self,master=self.master,bg=self.color)
		self.configure(height=self.hy,width=self.wx,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		self.drawbasewindow()
		self.pack(side=LEFT)
	def drawbasewindow(self):
		if self.shade==1:
			color=""
			for i in range((self.wx/2)):
				color = RGB2STR(self.colorTable1[i])
				self.create_line(0+i,0,0+i,self.hy,fill=color)
				self.create_line(self.wx-i-1,0,self.wx-i-1,self.hy,fill=color)
		if self.grille!=0:
			for b in range(self.hole):
				a=b*8
				for i in range(len(self.colorTable2)):
					color = RGB2STR(self.colorTable2[i])
					self.create_line(self.poly[0],self.poly[1]+(a)+i,self.poly[2],self.poly[3]+(a)+i,self.poly[4],self.poly[5]+(a)+i,self.poly[6],self.poly[7]+(a)+i,fill=color)


if __name__=="__main__":
	from Tkinter import *
	from CLASS_TIMER import*
	root=Tk()
	root.title("CLASS_BOX_ELEMENT")
	v = 0.0
	def incsec():
		global v
		v = v + 1.0
		timer.Set(v)

	def incmsec():
		global v
		v = v + 0.1
		timer.Set(v)
	frame = Frame(root,bg="#000000",border=2,relief=FLAT)
	button = Button(frame,text="INC Sec",command=incsec)
	button.pack(side=LEFT)
	button1 = Button(frame,text="INC MSec",command=incmsec)
	button1.pack(side=LEFT)
	rgb = [255,200,100]
	front=FRONTBOX(frame,rgb=rgb,width=300)
	capleft = CAPBOX(front,side="LEFT",rgb=rgb)
	timer = TIMER(front,rgb=rgb)
	SW = STRING_WINDOW(frame,wx=100)
	SW.pack(side=LEFT)
	capright = CAPBOX(front,side="RIGHT",rgb=rgb)
	frame.pack(side=TOP)
	root.mainloop()

