#!/usr/bin/python

######## EMI_ELEMENTS_4_BOX_CREATION #######
#             FLB STUDIO 2K4 (c) 2003-2004 #
############################################
#                           EMI CHAIN BOX  #
############################################

from Tkinter import *
from tkFileDialog import *
from CLASS_BOX_ELEMENTS import *
from CLASS_MENU_BUTTON import *
from CLASS_FX_MENU import *
from CLASS_NUMERIC_LED import *
from CLASS_TIMER import *
from CLASS_TOGGLE_BUTTON import *
from COLOR_FADER import *

class CHAIN(Frame):
	def __init__(self,master=None,ID=0,ECATALK=None,EMICOM=None,CHAINCOM=None):
		self.IN = ""
		self.OUT = None
		self.ID = ID
		self.action = 0
		self.master = master
		self.rgb = [200,175,0]
		self.hy = 100
		self.color = RGB2STR(self.rgb)
		self.EMICOM = EMICOM
		self.ECATALK=ECATALK
		self.CHAINCOM =CHAINCOM
		self.strwin = None
		self.timeLength = 0.0
		self.timeStart = 0.0
		self.timeEnd = 0.0
		self.timeOffset = 0.0
		self.isRec=0
		self.recString=None
		self.chain_name=None
		Frame.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000",width=800)
		self.lscrew = SCREWS(self,side="LEFT",hy=self.hy)
		self.frontA=Frame(self,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor=self.color,highlightbackground=self.color)
		self.frontA.pack(side=LEFT)
		self.frontB=Frame(self.frontA,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor=self.color,highlightbackground=self.color)
		self.frontB.pack(side=TOP)
		self.frontC=Frame(self.frontA,bg=self.color,border=0,highlightthickness=0,borderwidth=0,highlightcolor=self.color,highlightbackground=self.color)
		self.frontC.pack(side=BOTTOM)
		self.front = FRONTBOX(self.frontB,rgb=self.rgb,width=1024,hy=50)
		self.capleft = CAPBOX(self.front,side="LEFT",rgb=self.rgb,hy=50)
		self.label1 = Label(self.front,text="C",bg=self.color,fg=(RGB2STR(RGBGETHIGHLIGHT(self.rgb))),width=6).pack(side=LEFT)
		self.fxMenu = FX_MENU(master=self.master,ID=self.ID,EMICOM=self.EMICOM,CHAINCOM=self.CHAINCOM,BOX=self,ECATALK=self.ECATALK,bkcolor=self.color)
		self.acButton = MENU_BUTTON(self.front,rgb=self.rgb,command=self.fxMenu.popup,txt="C")
		self.indexled= NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="ID")
		self.indexled.pack(side=LEFT)
		self.BSpacer1=BOX_SPACER(self.front,rgb=self.rgb,wx=10,hy=30,shade=0)
		self.muteButton = TOGGLE_BUTTON(self.front,rgb=self.rgb,textColor=["#000000","#FFFFFF"],bc=[150,100,0],txt="M",command=self.mute)
		self.bypassButton = TOGGLE_BUTTON(self.front,rgb=self.rgb,textColor=["#000000","#FFFFFF"],bc=[0,100,150],txt="B",command=self.bypass)
		self.recButton = TOGGLE_BUTTON(self.front,rgb=self.rgb,textColor=["#000000","#FFFFFF"],bc=[150,0,0],txt="R",command=self.record)
		self.fxshowButton = TOGGLE_BUTTON(self.front,rgb=self.rgb,textColor=["#000000","#FFFFFF"],bc=[100,100,0],txt="-",txton="-",command=self.CHAINCOM[8])
		self.BSpacer2=BOX_SPACER(self.front,rgb=self.rgb,wx=10,hy=30,shade=0)
		self.LED_WINDOW = STRING_WINDOW(self.front,rgb=self.rgb,wx=476,hy=30)
		self.capright1 = CAPBOX(self.front,side="RIGHT",rgb=self.rgb,hy=50)
		self.front2=FRONTBOX(self.frontC,rgb=self.rgb,width=1024,hy=50)
		self.capleft2 = CAPBOX(self.front2,side="LEFT",rgb=self.rgb,hy=50)
		self.timelength = NUMERIC_LED_SET(self.front2,rgb=self.rgb,v=0,Qut=7,title="LEN",maximum=9999999,isFloat=3)
		self.timelength.pack(side=LEFT)
		self.timeplayposition = NUMERIC_LED_SET(self.front2,rgb=self.rgb,v=0,Qut=7,title="STA",editable=0,maximum=9999999,isFloat=3)
		self.timeplayposition.pack(side=LEFT)
		self.timeoffset = NUMERIC_LED_SET(self.front2,rgb=self.rgb,v=0,Qut=7,title="OFF",editable=1,maximum=9999999,command=self.calculateOffset,isFloat=3)
		self.timeoffset.pack(side=LEFT)
		self.timeplaylength = NUMERIC_LED_SET(self.front2,rgb=self.rgb,v=0,Qut=7,title="END",editable=0,maximum=9999999,isFloat=3)
		self.timeplaylength.pack(side=LEFT)
		self.capright2 = CAPBOX(self.front2,side="RIGHT",rgb=self.rgb,hy=50)
		self.rscrew = SCREWS(self,side="RIGHT",hy=self.hy)
		self.pack(side=TOP,fill=X)
		self.SetID(self.ID)
	def bypass(self=None,event=None):
		cn=self.EMICOM[20](self.ID)
		self.ECATALK.command(("c-select " + cn))
		self.ECATALK.command("c-bypass")
		self.EMICOM[21](("TOGGLE BYPASS CHAIN "+str(self.ID)))
	def mute(self=None,event=None):
		cn=self.EMICOM[20](self.ID)
		self.ECATALK.command(("c-select " + cn))
		self.ECATALK.command("c-muting")
		self.EMICOM[21](("TOGGLE MUTE CHAIN "+str(self.ID)))
	def record(self=None,event=None):
		if (self.isRec==0) & (self.master.AIS!=None):
			self.ECATALK.command("engine-status")
			s =self.ECATALK.last_string()
			if s != "running":
				file_name = asksaveasfilename(filetypes=[("Audio MS","*.wav"),("MAC Audio","*.aif"),("Audio Track","*.cdr")])
				if file_name:
					space=self.master.checkSpace(file_name)
					if space != 0:
						self.EMICOM[21]("FILE NAME WITH "+str(space)+" SPACES,WICH IS NOT UNIX COMPATIBLE!\nREPLACE SPACE WITH '_' TO MAKE IT USABLE")
						self.recButton.Off()
					else:
						isit=self.EMICOM[44](file_name)
						if isit != 1:
							self.EMICOM[43](file_name)
							self.recString=file_name
							self.chain_name="CR"+str(self.ID)
							self.ECATALK.command("c-add "+self.chain_name)
							self.ECATALK.command("ao-add "+ file_name)
							self.ECATALK.command("c-select CP"+str(self.ID)+",CR"+str(self.ID))
							self.ECATALK.command("ai-select "+self.master.AIS)
							self.ECATALK.command("ai-attach ")
							self.EMICOM[21]("TOGGLE RECORDING ON")
							self.LED_WINDOW.Set(file_name)
							self.isRec=1
							self.recButton.On()
						else:
							self.EMICOM[21]("DUPLICATED INPUT NAME! ERROR!")
							self.recButton.Off()
				else:
					self.recButton.Off()
			elif s == "running":
				self.EMICOM[21]("ECASOUND ENGIN IS RUNNING CANNOT OPEN FILE")
				self.recButton.Off()
		elif (self.isRec==1) & (self.master.AIS!=None):
			self.ECATALK.command("c-select CR"+str(self.ID))
			self.ECATALK.command("c-remove")
			self.ECATALK.command("ao-select "+self.recString)
			self.ECATALK.command("ao-remove")
			self.EMICOM[42](self.recString)
			self.recString=None
			self.EMICOM[21]("TOGGLE RECORDING OFF")
			self.isRec=0
			self.recButton.Off()
			self.LED_WINDOW.Set("")
			self.EMICOM[45]()
			self.EMICOM[26]()
		else:
			self.EMICOM[21]("ADD INPUT FIRST")
			self.recButton.Off()

	def GetID(self=None,event=None):
		return self.ID
	def SetID(self=None,event=None):
		self.ID = event
		self.indexled.Set(self.ID)
		self.fxMenu.SetID(event)
	def SetLength(self=None,event=None):
		if event != None:
			self.timeLength = event
		else:
			self.timeLength = 0.0
		self.timelength.simpleSet((int(self.timeLength*1000)))
	def SetStartTime(self=None,event=None):
		s = self.CHAINCOM[6]()
		self.ECATALK.command("engine-status")
		es =self.ECATALK.last_string()
		if (es != "running") & (s!=None):
			if event != None:
				self.timeStart = float(event)/1000
			self.timeplayposition.simpleSet((int(self.timeStart*1000)))
			self.ResetTimeStart()
	def SetEndTime(self=None,event=None):
		if event != None:
			self.timeEnd = event
		self.timeplaylength.simpleSet((int(self.timeEnd*1000)))
	def SetOffsetTime(self=None,event=None):
		if event != None:
			self.timeOffset = event
		self.timeOffset.Set((int(self.timeEnd*1000)))
	def calculateOffset(self=None,event=None):
		s = self.CHAINCOM[6]()
		if s!=None:
			self.ECATALK.command("engine-status")
			es =self.ECATALK.last_string()
			if (s !=None) & (es != "running"):
				self.timeOffset=((float(event)/1000))
				self.SetEndTime((float(self.timeLength-self.timeOffset+self.timeStart)))
				cn=self.EMICOM[20](self.ID)
				self.ECATALK.command(("c-select " + cn))
				self.ECATALK.command(("ai-select "+self.master.AIS))
				self.ECATALK.command(("ai-selected"))
				ais=self.ECATALK.last_string()
				self.ECATALK.command(("ai-set-position "+str(float(event)/1000)))
				self.ECATALK.command("ai-get-position")
				fais=self.ECATALK.last_float()
				self.EMICOM[21](("FORWARDING "+ais+" TO POSTION: "+str(fais)))

			elif es != "running":
				self.timeoffset.simpleSet(0)
				self.EMICOM[21]("NO INPUT TO SET START POSITION ")
			elif s=="running":
				self.timeoffset.simpleSet(0)
				self.EMICOM[21]("ECASOUND IS RUNNING! \nCANNOT SET TO START POSITION!")
		else:
			self.timeStart = 0.0
			self.timeplayposition.simpleSet((int(self.timeStart*1000)))

	def ResetTimeStart(self=None,event=None):
			AIS=self.master.AIS
			self.ECATALK.command(("c-list"))
			self.ECATALK.command(("c-deselect all"))
			self.ECATALK.command(("ai-deselect all"))
			self.ECATALK.command(("ai-select " +AIS))
			self.ECATALK.command("ai-remove")
			cn=self.EMICOM[20](self.ID)
			self.ECATALK.command(("c-select "+cn))
			self.ECATALK.command(("ai-add " +AIS))
			self.ECATALK.command(("-y:"+str(self.timeStart)))
			s=self.ECATALK.last_string()
			es=self.ECATALK.last_error()
			self.EMICOM[21]((s+"\n"+es))
			self.EMICOM[26]()
			self.ECATALK.command("cs-connect")
			s=self.ECATALK.last_error()
			if s !="":
				self.EMICOM[21](("ECASOUND ERROR! \n"+s))
			self.timeEnd=((float(self.timeLength-self.timeOffset+self.timeStart)))
			self.timeplaylength.simpleSet((int(self.timeEnd*1000)))
			self.ECATALK.command("cs-disconnect")

if __name__=="__main__":

	root=Tk()
	root.title("CLASS_CHAIN")
	root.configure(bg="#000000")
	chain = CHAIN(root)

	root.mainloop()
