#!/usr/bin/python

######## EMI_ELEMENTS_4_BOX_CREATION ###########
#                 FLB STUDIO 2K4 (c) 2003-2004                      #
#############################################
#                        FLANGER EMI ETL BOX                            #
#############################################

from Tkinter import *
from CLASS_BOX_ELEMENTS import *
from CLASS_MENU_BUTTON import *
from CLASS_FX_BOX_MENU import *
from CLASS_NUMERIC_LED import *

class ETL(Frame):
	def __init__(self,master=None,ID=0,EMICOM=None,ECATALK=None,parentID=None,CHAINCOM=None):
		self.EMICOM=EMICOM
		self.CHAINCOM=CHAINCOM
		self.ECATALK = ECATALK
		self.ID = ID
		self.parentID = parentID
		self.action = 0
		self.master = master
		self.rgb = [75,75,100]
		self.hy = 50
		self.color = RGB2STR(self.rgb)
		self.indexled = None
		self.dtmled = None
		self.vtsled = None
		self.fbkled = None
		self.lfoled = None
		self.dtmV=2
		self.vtsV=20
		self.fbkV=50
		self.lfoV=40
		Frame.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000",width=800)
		self.front = FRONTBOX(self,rgb=self.rgb,width=1024)
		self.lscrew = SCREWS(self.front,side="LEFT")
		self.capleft = CAPBOX(self.front,side="LEFT",rgb=self.rgb)
		self.label1 = Label(self.front,text="ETL",bg=self.color,fg=(RGB2STR(RGBGETHIGHLIGHT(self.rgb))),width=6).pack(side=LEFT)
		self.fxMenu = FX_BOX_MENU(EMICOM=self.EMICOM,CHAINCOM=self.CHAINCOM,ECATALK=self.ECATALK,bkcolor=self.color,ID=self.ID,parentID=self.parentID,command=self.rembox)
		self.acButton = MENU_BUTTON(self.front,rgb=self.rgb,command=self.fxMenu.popup,txt="C")
		self.indexled= NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="ID")
		self.indexled.pack(side=LEFT)
		self.spacer0 = FRONTBOX(self.front,rgb=self.rgb,width=10)
		self.dtmled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="DTM",editable=1,command=self.SetDTM,maximum=999,roller=1,rollercolorcap="#FFEE00")
		self.dtmled.pack(side=LEFT)
		self.vtsled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="VTS",editable=1,command=self.SetVTS,maximum=999,roller=1,rollercolorcap="#FFEE00")
		self.vtsled.pack(side=LEFT)
		self.fbkled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=2,title="FBK",editable=1,command=self.SetFBK,maximum=99,roller=1,rollercolorcap="#FFEE00")
		self.fbkled.pack(side=LEFT)
		self.lfoled=NUMERIC_LED_SET(self.front,rgb=self.rgb,v=0,Qut=3,title="LFO",editable=1,command=self.SetLFO,maximum=999,roller=1,rollercolorcap="#FFEE00",isFloat=2)
		self.lfoled.pack(side=LEFT)
		self.spacer1 = BOX_SPACER(self.front,rgb=self.rgb,wx=54)
		self.rscrew = SCREWS(self.front,side="RIGHT")
		self.capright = CAPBOX(self.front,side="RIGHT",rgb=self.rgb)
		self.pack(side=TOP,fill=X)
		self.SetID(self.ID)
		self.dtmled.simpleSet(self.dtmV)
		self.vtsled.simpleSet(self.vtsV)
		self.fbkled.simpleSet(self.fbkV)
		self.lfoled.simpleSet(self.lfoV)
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command(("c-select " + cn))
		self.ECATALK.command("cop-add -etl:+"+str(self.dtmV)+","+str(self.vtsV)+","+str(self.fbkV)+","+str(float(self.lfoV)/100))
		self.EMICOM[21](("COP ETL (FLANGER) IS ADD TO CHAIN "+cn+" AT INDEX "+str(self.ID)))
	def rembox(self=None,event=None):
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("cop-remove")
		self.EMICOM[21](("COP ETL (FLANGER) IS REMOVE FROM CHAIN "+cn+" AT INDEX "+str(self.ID)))
		self.CHAINCOM[1](self.ID)
	def SetParentID(self=None,event=None):
		self.parentID = event
		self.fxMenu.SetParentID(self.parentID)
	def SetID(self=None,event=None):
		self.ID = event
		self.fxMenu.SetID(self.ID)
		self.indexled.Set(self.ID)
	def GetID(self=None,event=None):
		return self.ID
	def SetDTM(self=None,event=None):
		self.dtmV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 1")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etl AT INDEX "+str(self.ID)+"\nCOPP DELAY AT INDEX 1\nSET TO "+str(event)+" Msec"))
	def SetVTS(self=None,event=None):
		self.vtsV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 2")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etl AT INDEX "+str(self.ID)+"\nCOPP VARIANCE TIME SAMPLE AT INDEX 2\nSET TO "+str(event)+" Msec"))
	def SetFBK(self=None,event=None):
		self.fbkV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 3")
		self.ECATALK.command(("copp-set "+str(event)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etl AT INDEX "+str(self.ID)+"\nCOPP FEEDBACK AT INDEX 3\nSET TO "+str(event)+" %"))
	def SetLFO(self=None,event=None):
		self.lfoV=event
		cn=self.EMICOM[20](self.parentID)
		self.ECATALK.command("c-select "+cn)
		self.ECATALK.command(("cop-index-select "+str(self.ID)))
		self.ECATALK.command("copp-index-select 4")
		self.ECATALK.command(("copp-set "+str(float(event)/100)))
		self.EMICOM[21](("CHAIN "+cn+" AT INDEX "+str(self.parentID)+"\nCOP -etl AT INDEX "+str(self.ID)+"\nCOPP LFO FREQENCY AT INDEX 4\nSET TO "+str(float(event)/100)))
	def GetDTM(self=None,event=None):
		return self.dtmV
	def GetVTS(self=None,event=None):
		return self.vtsV
	def GetFBK(self=None,event=None):
		return self.fbkV
	def GetLFO(self=None,event=None):
		return self.lfoV



if __name__=="__main__":

	root=Tk()
	root.title("CLASS_ETE")
	root.configure(bg="#000000")
	ete = ETE(root)

	root.mainloop()
