#!/usr/bin/python
#[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
##################################}@{
#
#	EMI(C)2003-2004 FLB STUDIO 2K4
#	Autor : Felix Le Blanc Mtl
#
##################################}@{
#
#	GRAPH Class library for Emi:
#
#		Class SCREWS : Draw Panel Screws
#		Class CAPBOX : Draw Panel Corners
#		Class FRONTBOX : Draw Front Panel
#		Class FRONTBOX : Draw Front Panel
#		Class ROLL_BUTTON : Roll Button Constructor
#		Class STRING_WINDOW : Led Window Constroctor
#		Class BOX_SPACER : Shade/hole/fan or Spacer Constroctor
#
##################################}@{
#]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

from Tkinter import *
from COLOR_FADER import *
from CLASS_NUMERIC_LED import *
import time
class ENVELOPE_GRAPH(Canvas):
	def __init__(self,master=None,wx=720,hy=70,rgb=[255,0,0],startvalue=0,endvalue=100,temp=105000,command=None,dynamic=1):
		self.master = master
		self.wx=wx
		self.hy=hy
		self.rgb = rgb
		self.graphcolor=RGB2STR(RGBGETVERYHIGHLIGHT(self.rgb))
		self.graphshadow="#393939"
		self.color = "#%02X%02X%02X" % (self.rgb[0],self.rgb[1],self.rgb[2])
		self.x=0
		self.y=0
		self.endvalue = endvalue
		self.startvalue = startvalue
		self.totalvalue=(self.endvalue-self.startvalue)
		self.temp=temp
		self.echeltemp=1
		self.echelvaleur=1
		self.coords=[]
		self.nodes=[]
		self.lines=[0,0]
		self.space=10
		self.xytexte=None
		self.colorTable=RGB2RGB(self.rgb,[0,0,0],self.space)
		self.windowColorTable=RGB2RGB([0,0,0],[35,35,65],(self.wx/2-self.space))
		self.command=command
		self.ix=0
		self.iy=0
		self.NUMNODES=0
		self.dynamic=dynamic
		Canvas.__init__(self,master=self.master)
		self.configure(bg="#000000",border=0,highlightthickness=0,borderwidth=1,highlightcolor="#393939",highlightbackground="#393939",width=self.wx,height=self.hy)
		self.drawbasewindow()
		self.draw_graph()
		if self.dynamic > 0:
			self.bind("<Double-Button-1>",self.make_node)
			self.bind("<Motion>",self.get_mouse)
			self.bind("<1>",self.move)
			self.bind("<Enter>",self.CursorOn)

	def trier(self=None,event=None):
		print "trier"
	def move(self=None,event=None):
		t=len(self.nodes)
		node=None
		for i in range(t):
			if self.nodes[i].toggle==1:
				node=i
		if node!=None:
			self.nodes[node].ext_move()
	def CursorOn(self=None,event=None):
		self.configure(cursor="plus")
	def make_node(self=None,event=None):
		s=self.get_ix_iy(event)
		self.nodes.append(0)
		t=len(self.nodes)
		self.nodes[(t-1)]=NODES(self,x=event.x,y=event.y,ID=(t-1))
		self.rem_line()
		self.add_line()
		self.idp()

	def get_ix_iy(self=None,event=None):
		if event.x>self.wx-self.space:
			self.x=self.wx-self.space
		elif event.x<self.space:
			self.x=self.space
		else:
			self.x=event.x
 		if event.y>self.hy-self.space:
			self.y=self.hy-self.space
		elif event.y<self.space:
			self.y=self.space
		else:
			self.y=event.y

		ix=((self.x-self.space)*self.echeltemp)
		iy=((self.hy-self.y-self.space)*self.echelvaleur)
		if iy<0:
			iy=0
		if ix<0:
			ix=0
		if iy>self.endvalue:
			iy=self.endvalue
		if ix>self.temp:
			ix=self.temp
		self.ix=ix
		self.iy=iy
		return (self.ix,self.iy)

	def get_mouse(self=None,event=None):
		if event.x>self.wx-self.space:
			self.x=self.wx-self.space
		elif event.x<self.space:
			self.x=self.space
		else:
			self.x=event.x
		if event.y>self.hy-self.space:
			self.y=self.hy-self.space
		elif event.y<self.space:
			self.y=self.space
		else:
			self.y=event.y
		ix=((self.x-self.space)*self.echeltemp)
		iy=((self.hy-self.y-self.space)*self.echelvaleur)
		if iy<0:
			iy=0
		if ix<0:
			ix=0
		if iy>self.endvalue:
			iy=self.endvalue
		if ix>self.temp:
			ix=self.temp
		if self.command!=None:
			self.command([ix,iy])
		self.ix=ix
		self.iy=iy
	def drawbasewindow(self=None,event=None):
		for i in range(len(self.colorTable)):
			color = RGB2STR(self.colorTable[i])
			self.create_line(i,i,self.wx-i,i,fill=color)
			self.create_line(i,self.hy-i,self.wx-i,self.hy-i,fill=color)
			self.create_line(i,i,i,self.hy-i,fill=color)
			self.create_line(self.wx-i,i,self.wx-i,self.hy-i+1,fill=color)
		for i in range(len(self.windowColorTable)):
			color = RGB2STR((self.windowColorTable[i]))
			self.create_line(i+self.space,self.space,i+self.space,self.hy-self.space,fill=color)
			self.create_line(self.wx-i-self.space,self.space,self.wx-i-self.space,self.hy-self.space,fill=color)
	def draw_graph(self=None,event=None):
		if self.temp>(self.wx-(self.space*2)):
			self.echeltemp=self.temp/(self.wx-(self.space*2))
		elif self.temp<(self.wx-(self.space*2)):
			self.echeltemp=(self.wx-(self.space*2))/self.temp
		elif self.temp==(self.wx-(self.space*2)):
			self.echeltemp=1
		if self.totalvalue>(self.hy-(self.space*2)):
			self.echelvaleur=self.totalvalue/(self.hy-(self.space*2))
		elif self.totalvalue<(self.hy-(self.space*2)):
			self.echelvaleur=(self.hy-(self.space*2))/self.totalvalue
		elif self.totalvalue==(self.hy-(self.space*2)):
			self.echelvaleur=1
		for i in range(int(self.wx-(self.space*2)/10)):
			self.create_line((self.space+(i*10)),self.space,(self.space+(i*10)),(self.hy-self.space),fill=self.graphshadow)
		for i in range(int(self.hy-(self.space*2)/10)):
			self.create_line(self.space,(self.space+(i*10)),(self.wx-self.space),(self.space+(i*10)),fill=self.graphshadow)
	def rem_node(self=None,event=None):
		for i in range(len(self.nodes)):
			if i < len(self.nodes):
				if self.nodes[i].ID==event:
					self.nodes[i].destroy()
					self.nodes.remove(self.nodes[i])
		if len(self.nodes)>1:
			xV=[]
			newxV=[]
			for i in range(len(self.nodes)):
				xV.append(self.nodes[i].x)
				newxV.append(self.nodes[i].x)
			newxV.sort()
			for i in range(len(self.nodes)):
				ci=xV.index(newxV[i])
				self.nodes[ci].ID=i
		elif len(self.nodes)==1:
			self.nodes[0].ID=0
		self.idp()
	def add_line(self=None,event=None):
		if len(self.nodes)>1:
			self.coords=[0]*(len(self.nodes)*2)
			xV=[]
			newxV=[]
			for i in range(len(self.nodes)):
				xV.append(self.nodes[i].x)
				newxV.append(self.nodes[i].x)
			newxV.sort()
			for i in range(len(self.nodes)):
				ci=xV.index(newxV[i])
				self.nodes[ci].ID=i
			for i in range(len(self.nodes)):
				co=self.nodes[i].Getxy()
				coid=self.nodes[i].ID
				x=co[0]
				y=co[1]
				self.coords[(coid*2)]=x
				self.coords[(coid*2+1)]=y
			if len(self.coords)>3:
				self.lines[0]=self.create_line(self.coords,fill="#AABB00",width=2,smooth=1)
				self.lines[1]=self.create_line(self.coords,fill="#696969",width=1,smooth=0)

	def set_line(self=None,event=None):
		print "set_line"
	def rem_line(self=None,event=None):
		self.delete(self.lines[0])
		self.delete(self.lines[1])
		self.coords=[]
	def idp(self=None,event=None):
		for i in range(len(self.nodes)):
			self.nodes[i].idprint()



class NODES(Canvas):
	def __init__(self,master=None,x=None,y=None,ID=None):
		self.x=x
		self.y=y
		self.master=master
		self.ID=ID
		self.toggle=0
		self.texte=None
		self.dynamic=master.dynamic
		Canvas.__init__(self,master=self.master)
		self.configure(bg="#FF0000",border=0,highlightthickness=0,borderwidth=0,highlightcolor="#FFFFFF",highlightbackground="#393939",width=13,height=13,relief=FLAT)
		self.place(x=(self.x-7),y=(self.y-7))
		self.texte=self.create_text(7,7,text=str(self.ID),fill="#FFFFFF",anchor=CENTER)
		if self.dynamic > 0:
			self.bind("<Button-3>",self.kill)
		self.bind("<Button-1>",self.move)
		self.bind("<Enter>",self.CursorOn)
	def idprint(self=None,event=None):
		self.delete(self.texte)
		self.texte=self.create_text(7,7,text=str(self.ID),fill="#FFFFFF",anchor=CENTER)
	def Getxy(self=None,event=None):
		return (self.x,self.y)
	def CursorOn(self=None,event=None):
		self.configure(cursor="crosshair")
	def kill(self=None,event=None):
		self.master.delete(self.texte)
		self.master.rem_node(self.ID)
		self.master.rem_line()
		self.master.add_line()
	def ext_move(self=None,event=None):
		if self.toggle==1:
			self.toggle=0
			self.moveit()
	def move(self=None,event=None):
		if self.toggle==0:
			self.toggle=1
			self.place(x=(-100),y=(-100))
			self.moveit()
	def moveit(self=None,event=None):
		if self.toggle==1:
			self.x=self.master.x
			self.y=self.master.y
			self.master.coords[self.ID*2]=self.x
			self.master.coords[self.ID*2+1]=self.y
			self.master.rem_line()
			self.master.add_line()
			self.after(100,self.moveit)
			self.master.idp()
		else:
			self.place(x=(self.master.x-7),y=(self.master.y-7))
			self.master.rem_line()
			self.master.add_line()
			self.master.idp()


if __name__=="__main__":
	root=Tk()
	root.title("CLASS_GRAPH")
	rgb=[200,0,0]
	bg=RGB2STR(rgb)
	root.configure(bg=bg)
	frame=Frame(root,bg=bg)
	frame.pack(side=TOP)
	ledx=NUMERIC_LED_SET(frame,rgb=rgb,v=0,Qut=7,title="TMS",editable=0,command=None,maximum=9999999)
	ledx.pack(side=LEFT)
	ledy=NUMERIC_LED_SET(frame,rgb=rgb,v=0,Qut=3,title="VOL",editable=0,command=None,maximum=999)
	ledy.pack(side=LEFT)
	def setledset(event=None):
		global ledx,ledy
		ledx.simpleSet((event[0]))
		ledy.simpleSet((event[1]))
	graph =  ENVELOPE_GRAPH(root,command=setledset)
	graph.pack(side=TOP)
	root.mainloop()

