#!/usr/bin/python
#[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
##################################
#             EMi Version 1.5.1 Stable
#   EMI(C)2003-2004 FLB STUDIO 2K4
#	Autor : Felix Le Blanc Mtl
#                flb@flbstudio.com
#           http://emi.thevtek.com
##################################
#	CLASS : EMI
##################################
#]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
#############################################################################################################
#Preamble
#############################################################################################################
#The intent of this document is to state the conditions under which a Package may be copied, such that the 
#Copyright Holder maintains some semblance of artistic control over the development of the package, while 
#giving the users of the package the right to use and distribute the Package in a more-or-less customary 
#fashion, plus the right to make reasonable modifications.
#############################################################################################################
#Definitions:
#
#    * "Package" refers to the collection of files distributed by the Copyright Holder, and derivatives of 
#       that collection of files created through textual modification.
#    * "Standard Version" refers to such a Package if it has not been modified, or has been modified in 
#       accordance with the wishes of the Copyright Holder.
#    * "Copyright Holder" is whoever is named in the copyright or copyrights for the package.
#    * "You" is you, if you're thinking about copying or distributing this Package.
#    * "Reasonable copying fee" is whatever you can justify on the basis of media cost, duplication 
#       charges, time of people involved, and so on. (You will not be required to justify it to the 
#       Copyright Holder, but only to the computing community at large as a market that must bear the fee.)
#    * "Freely Available" means that no fee is charged for the item itself, though there may be fees involved 
#       in handling the item. It also means that recipients of the item may redistribute it under the same 
#       conditions they received it.
#
#1. You may make and give away verbatim copies of the source form of the Standard Version of this Package 
#   without restriction, provided that you duplicate all of the original copyright notices and associated disclaimers.
#
#2. You may apply bug fixes, portability fixes and other modifications derived from the Public Domain or from the 
#   Copyright Holder. A Package modified in such a way shall still be considered the Standard Version.
#
#3. You may otherwise modify your copy of this Package in any way, provided that you insert a prominent notice 
#   in each changed file stating how and when you changed that file, and provided that you do at least ONE of the following:
#
#    a) place your modifications in the Public Domain or otherwise make them Freely Available, such as by 
#    posting said modifications to Usenet or an equivalent medium, or placing the modifications on a major 
#    archive site such as ftp.uu.net, or by allowing the Copyright Holder to include your modifications 
#    in the Standard Version of the Package.
#
#    b) use the modified Package only within your corporation or organization.
#
#    c) rename any non-standard executables so the names do not conflict with standard executables, 
#    which must also be provided, and provide a separate manual page for each non-standard executable 
#    that clearly documents how it differs from the Standard Version.
#
#    d) make other distribution arrangements with the Copyright Holder.
#
#4. You may distribute the programs of this Package in object code or executable form, 
#   provided that you do at least ONE of the following:
#
#    a) distribute a Standard Version of the executables and library files, together with 
#    instructions (in the manual page or equivalent) on where to get the Standard Version.
#
#    b) accompany the distribution with the machine-readable source of the Package with your modifications.
#
#    c) accompany any non-standard executables with their corresponding Standard Version executables, giving 
#    the non-standard executables non-standard names, and clearly documenting the differences in manual 
#    pages (or equivalent), together with instructions on where to get the Standard Version.
#
#    d) make other distribution arrangements with the Copyright Holder.
#
#5. You may charge a reasonable copying fee for any distribution of this Package. You may charge any fee 
#   you choose for support of this Package. You may not charge a fee for this Package itself. 
#   However, you may distribute this Package in aggregate with other (possibly commercial) programs as 
#   part of a larger (possibly commercial) software distribution provided that you do not advertise 
#   this Package as a product of your own.
#
#6. The scripts and library files supplied as input to or produced as output from the programs of this Package 
#   do not automatically fall under the copyright of this Package, but belong to whomever generated them, 
#   and may be sold commercially, and may be aggregated with this Package.
#
#7. C or perl subroutines supplied by you and linked into this Package shall not be considered part of this Package.
#
#8. The name of the Copyright Holder may not be used to endorse or promote products derived from this software 
#   without specific prior written permission.
#
#9. THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, 
#   WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
#################################################################################################################
#   The End
#################################################################################################################

from Tkinter import *
import sys
import time
from pyeca import *
from tkFileDialog import *
import tkMessageBox
from tkSimpleDialog import *
from CLASS_TRANSPORT import *
from CLASS_SCROLLBAR import *
from CLASS_STATUSBAR import *
from CLASS_CHAIN_TRACKER import *
from CLASS_ECA_OUT import *
from COLOR_FADER import *

try:
	import psyco #uncomment to import psyco
	psyco.full() 
except:
	print "install psyco to speed up EMI  (2X faster!)"
	

class EMI(Canvas):
	def __init__(self,master=None,ww=None):
		self.ECATALK = ECA_CONTROL_INTERFACE()
		self.CHAIN_SETUP_NAME = "EMICS"
		self.GOOD_CHAIN=0
		self.CHAINS = []
		self.AI_LIST=[]
		self.PBK_DEVICE = "/dev/dsp"
		self.REC_DEVICE = "/dev/dsp"
		self.ALL_AIS=[]
		self.ALL_AOS=[]
		self.EMICOMDES=['Create EMICOM INDEX html doc','Remove specified chain','Open (ecs) file','Save (ecs) file','Save as (ecs) file','Configure audio device','Configure tool','Add chain','Print help about (emi) (eca)','Help (doc)','Print related Web site','CS to start','CS rewind','CS play','CS stop and go to start','CS pause(stop and keep position)','CS forward','EMI exit callback','Ask for chain name','Return list of all playback chains','Ask for chain number','Print a message (event or string) to the emi terminal','Removing null input','remove to all input string','Add to all input string','Check if chain have input string','Attach all inpout and output','Get and Print CS status to EMI terminal','Get and print audio device setup to EMI terminal','Get and print chain status to EMI terminal','Set offset timer','Toggle fullscreen','Hide main window','Show main window','Get and print COP status to EMI terminal','Get and print CTRL status to EMI terminal','Get and print CS list to EMI terminal','Get and print C list to EMI terminal','Get and print AI list to EMI terminal','Get and print AO list to EMI terminal','Get and print COP list to EMI terminal','Get and print CTRL list to EMI terminal','Removes to all aos','Add to all aos','Check if specified chain have aos','Attach all output string (aos)']
		self.EMICOMSTR=['self.print_command','self.rem_chain','self.openFile','self.saveFile','self.saveFileAs','self.setAudioDev','self.setTool','self.addChain','self.aboutHelp','self.emiHelp','self.wwwHelp','self.toStart','self.rew','self.play','self.stop','self.pause','self.ff','self.meurt','self.GetChainNames','self.GetChainP','self.GetChainNum','self.SendEcaOut','self.remNullAI','self.remove_to_all_ais','self.add_to_all_ais','self.check_if_ais_is','self.attach_all','self.get_cs_status','self.get_audio_setup','self.get_c_status','self.setOffsetTimers','self.togglefullscreen','self.hidemaster','self.showmaster','self.get_cop_status','self.get_ctrl_status','self.get_cs_list','self.get_c_list','self.get_ai_list','self.get_ao_list','self.get_cop_list','self.get_ctrl_list','self.remove_to_all_aos','self.add_to_all_aos','self.check_if_aos_is','self.attach_all_aos']
		self.EMICOM=[self.print_command,self.rem_chain,self.openFile,self.saveFile,self.saveFileAs,self.setAudioDev,self.setTool,self.addChain,self.aboutHelp,self.emiHelp,self.wwwHelp,self.toStart,self.rew,self.play,self.stop,self.pause,self.ff,self.meurt,self.GetChainNames,self.GetChainP,self.GetChainNum,self.SendEcaOut,self.remNullAI,self.remove_to_all_ais,self.add_to_all_ais,self.check_if_ais_is,self.attach_all,self.get_cs_status,self.get_audio_setup,self.get_c_status,self.setOffsetTimers,self.togglefullscreen,self.hidemaster,self.showmaster,self.get_cop_status,self.get_ctrl_status,self.get_cs_list,self.get_c_list,self.get_ai_list,self.get_ao_list,self.get_cop_list,self.get_ctrl_list,self.remove_to_all_aos,self.add_to_all_aos,self.check_if_aos_is,self.attach_all_aos]
		self.master=master
		self.ww=ww
		self.px=(self.ww-900)/2
		self.colorTable=RGB2RGB([0,0,30],[49,49,79],(self.ww/2))
		self.visible=1
		self.isFullScreen=0
		Canvas .__init__(self,master=self.master,bg="#000000",width=self.ww,height=1024,border=0,highlightthickness=0,borderwidth=0,highlightcolor="#000000",highlightbackground="#000000")
		for i in range((ww/2)):
   			color = RGB2STR(self.colorTable[i])
			self.create_line(0+i,0,0+i,1024,fill=color)
			self.create_line(self.ww-1-i,0,self.ww-1-i,1024,fill=color)
		self.mainFrame = Frame(self.master,bg="#000000",width=800)
		self.mainFrame.place(x=0,y=0)
		self.scrollbar = SCROLL_BAR(self.master,scrollItem=self.mainFrame)
		self.scrollbar.pack(side=RIGHT,fill=Y)
		self.transport = TRANSPORT(self.mainFrame,EMICOM=self.EMICOM,ECATALK=self.ECATALK)
		self.ecaout= ECA_OUT(self.mainFrame,EMICOM=self.EMICOM,ECATALK=self.ECATALK,texte="None")
		self.place(x=0,y=0)
		if self.ECATALK!=None:
			self.ECATALK.command("cs-remove")
			self.ECATALK.command(("cs-add "+self.CHAIN_SETUP_NAME))
			self.master.title(("EMI-1.5 STABLE - The Ecasound Mastering Interface - "+self.CHAIN_SETUP_NAME))
			self.ECATALK.command(("ao-add "+self.PBK_DEVICE))
			self.ALL_AOS.append(0)
			self.ALL_AOS[0]=self.PBK_DEVICE
			self.EMICOM[21](("WELCOME TO EMI"))
		else:
			self.EMICOM[21]("ECASOUND IS NOT PRESENT OR PYECA IS NOT IN PYTHON SITE-PACK DIR!")
		self.master.focus()
		self.masterbindings()
	def masterbindings(self=None,event=None):
		self.master.bind('<Up>',self.scrollbar.setDw)
		self.master.bind('<Down>',self.scrollbar.setUp)
		#self.master.bind('f',self.togglefullscreen)
	def togglefullscreen(self=None,event=None):
		if self.isFullScreen==1:
			self.fullscreenOff()
			self.masterbindings()
			self.isFullScreen=0
		else:
			self.fullscreenOn()
			self.masterbindings()
			self.isFullScreen=1
	def fullscreenOn(self=None,event=None):
		self.master.withdraw()
		w, h = self.master.winfo_screenwidth(),self.master.winfo_screenheight()
		self.master.geometry("%dx%d+0+0" % (w, h))
		self.master.overrideredirect(1)
		self.master.deiconify()
		self.masterbindings()
		self.isFullScreen=1

	def fullscreenOff(self=None,event=None):
		self.master.withdraw()
		w, h = self.master.winfo_screenwidth(),self.master.winfo_screenheight()
		self.master.geometry("%dx%d+0+0" % (w, h))
		self.master.overrideredirect(0)
		self.master.deiconify()
		self.masterbindings()
		self.isFullScreen=0

	def hidemaster(self=None,event=None):
		self.master.withdraw()
		self.visible=0
	def showmaster(self=None,event=None):
		self.master.focus()
		self.master.deiconify()
		self.master.focus()
		self.visible=1

	def attach_all(self=None,event=None):
		for i in range(len(self.CHAINS)):
			if self.CHAINS[i].chain.recString!=None:
				self.ECATALK.command(("c-select "+self.CHAINS[i].chain_name+","+self.CHAINS[i].chain.chain_name))
				self.ECATALK.command(("ai-select "+self.CHAINS[i].AIS))
				self.ECATALK.command("ai-attach ")
			else:
				self.ECATALK.command(("c-select "+self.CHAINS[i].chain_name))
				self.ECATALK.command(("ai-select "+self.CHAINS[i].AIS))
				self.ECATALK.command("ai-attach ")
	def attach_all_aos(self=None,event=None):
		for i in range(len(self.CHAINS)):
			if self.CHAINS[i].chain.recString!=None:
				self.ECATALK.command(("c-select "+"CR"+str(self.CHAINS[i].ID)))
				self.ECATALK.command(("ao-select "+self.CHAINS[i].chain.recString))
				self.ECATALK.command("ao-attach ")
		s = self.GetChainP()
		self.ECATALK.command(("c-select "+s))
		self.ECATALK.command(("ao-select "+self.PBK_DEVICE))
		self.ECATALK.command("ao-attach ")
	def get_audio_setup(self=None,event=None):
		s="PLAYBACK DEVICE : "+self.PBK_DEVICE+"\nRECORDING DEVICE : "+self.REC_DEVICE
		self.EMICOM[21](s)
	def get_cs_status(self=None,event=None):
		self.ECATALK.command("cs-status")
		s=self.ECATALK.last_string()
		self.EMICOM[21](s)
	def get_c_status(self=None,event=None):
		self.ECATALK.command("c-status")
		s=self.ECATALK.last_string()
		self.EMICOM[21](s)
	def get_cop_status(self=None,event=None):
		self.ECATALK.command("cop-status")
		s=self.ECATALK.last_string()
		self.EMICOM[21](s)
	def get_ctrl_status(self=None,event=None):
		self.ECATALK.command("ctrl-status")
		s=self.ECATALK.last_string()
		self.EMICOM[21](s)
	def get_cs_list(self=None,event=None):
		self.ECATALK.command("cs-list")
		s=self.ECATALK.last_string_list()
		self.EMICOM[21](s)
	def get_c_list(self=None,event=None):
		self.ECATALK.command("c-list")
		s=self.ECATALK.last_string_list()
		self.EMICOM[21](s)
	def get_ai_list(self=None,event=None):
		self.ECATALK.command("ai-list")
		s=self.ECATALK.last_string_list()
		self.EMICOM[21](s)
	def get_ao_list(self=None,event=None):
		self.ECATALK.command("ao-list")
		s=self.ECATALK.last_string_list()
		self.EMICOM[21](s)
	def get_cop_list(self=None,event=None):
		self.ECATALK.command("cop-list")
		s=self.ECATALK.last_string_list()
		self.EMICOM[21](s)
	def get_ctrl_list(self=None,event=None):
		self.ECATALK.command("ctrl-list")
		s=self.ECATALK.last_string_list()
		self.EMICOM[21](s)

	def setOffsetTimers(self=None,event=None):
		s="cs-set-position 0.0\n"
		for i in range(len(self.CHAINS)):
			ais = self.CHAINS[i].AIS
			pos = str(self.CHAINS[i].chain.timeOffset)
			self.ECATALK.command(("ai-select "+ais))
			if self.CHAINS[i].chain.timeOffset != 0.0:
				self.ECATALK.command(("ai-setpos "+pos))
				s=s+ais+" ai-set-position "+pos+"\n"
		self.EMICOM[21](s)
	def check_if_ais_is(self=None,event=None):
		v=0
		for i in range(len(self.ALL_AIS)):
			if self.ALL_AIS[i]==event:
				v=1
		if v!=1:
			return 0
		else:
			return 1
	def check_if_aos_is(self=None,event=None):
		v=0
		for i in range(len(self.ALL_AOS)):
			if self.ALL_AOS[i]==event:
				v=1
		if v!=1:
			return 0
		else:
			return 1
	def add_to_all_ais(self=None,event=None):
		self.ALL_AIS.append(event)

	def remove_to_all_ais(self=None,event=None):
		self.ALL_AIS.remove(event)
	def add_to_all_aos(self=None,event=None):
		self.ALL_AOS.append(event)

	def remove_to_all_aos(self=None,event=None):
		self.ALL_AOS.remove(event)
	def remNullAI(self=None,event=None):
		print "s"
	def SendEcaOut(self=None,event=None):
		self.ecaout.Set(event)
	def GetChainNames(self=None,event=None):
		s = str(self.CHAINS_NAMES_P[event]+","+self.CHAINS_NAMES_R[event])
		return s
	def GetChainP(self=None,event=None):
		s=""
		for i in range(len(self.CHAINS)):
			if i != (len(self.CHAINS)-1):
				s= s + self.CHAINS[i].chain_name + ","
			else:
				s= s + self.CHAINS[i].chain_name
		return s
	def GetChainNum(self=None,event=None):
		s = self.CHAINS[event].chain_name
		return s
	def meurt(self=None,event=None):
  		sys.exit(0)
	def addChain(self=None,event=None):
		checkai = 0
		if (len(self.CHAINS)>0):
			for i in range(len(self.CHAINS)):
				if self.CHAINS[i].AISID ==None:
					checkai=checkai+1
					self.EMICOM[21](("CHAIN AT INDEX "+str(i)+" IS UNUSED! ADD INPUT OR REMOVE CHAIN "+str(i)+" !"))
		self.ECATALK.command("engine-status")
		s =self.ECATALK.last_string()
		if (s != "running") & (checkai==0):
			self.CHAINS.append(0)
			i = len(self.CHAINS) - 1
			self.CHAINS[i] = CHAIN_TRACKER(self.mainFrame,ID=i,EMICOM=self.EMICOM,ECATALK=self.ECATALK)
			sp="CP"+str(i)
			self.CHAINS[i].chain_name=sp
			self.ECATALK.command(("c-add "+sp))
			self.EMICOM[21](("CHAIN "+sp+" ADD TO CHAIN SETUP"))
			sallc=self.EMICOM[19]()
			self.ECATALK.command(("c-select "+ sallc))
			self.ECATALK.command("ao-select "+self.PBK_DEVICE)
			self.ECATALK.command("ao-attach")
			self.EMICOM[21](("CHAIN "+sp+" ATTACH TO DEVICE : "+self.PBK_DEVICE))
		elif checkai!=0:
			self.EMICOM[21]("YOU HAVE A UNUSED CHAIN, CANNOT ADD CHAIN")
		else:
			self.EMICOM[21]("ECASOUND ENGIN IS RUNNING CANNOT ADD CHAIN")
	def rem_chain(self=None,event=None):
		ID=event
		sp=self.CHAINS[ID].chain_name
		self.CHAINS[ID].destroy()
		self.ECATALK.command(("c-select "+sp))
		self.ECATALK.command("c-remove")
		self.EMICOM[21](("CHAIN "+sp+" REMOVED FROM CHAIN SETUP"))
		self.CHAINS.remove(self.CHAINS[ID])
		for i in range(len(self.CHAINS)):
			self.CHAINS[i].SetID(i)
			self.CHAINS[i].SendChainID(i)
			if self.CHAINS[i].chain_name != ("CP"+str(i)):
				self.ECATALK.command(("c-select "+self.CHAINS[i].chain_name))
				self.ECATALK.command(("c-rename "+"CP"+str(i)))
				self.CHAINS[i].chain_name="CP"+str(i)
				if self.CHAINS[i].chain.recString!=None:
					self.ECATALK.command(("c-select "+self.CHAINS[i].chain.chain_name))
					self.ECATALK.command(("c-rename "+"CR"+str(i)))
					self.CHAINS[i].chain.chain_name="CR"+str(i)

		self.attach_all()
	def print_command(self=None,event=None):
		self.EMICOM[21]("List EMICOM to HTML DOC")
		FILE=open("EMICOM.html","wb")
		FILE.write('<html><header><title>EMICOM INDEX (EMi) FLB STUDIO 2K5</title></header><body><h1>EMICOM INDEX</h1>EMi class offer EMICOM service as a central command list, it work from any class that implement it.<br> command look like this : self.EMICOM[ID](arg)')
		FILE.write("<br><br><table width='100%' bgcolor='#ffffff' cellspacing='5' cellppading='5'>")
		FILE.write("<tr bgcolor='#ff00ff'><td width'100'>ID</td><td>EMI CLASS FUNCTION LINKED TO ID NUMBER</td><td>ACTION DESCRIPTION</td></tr>")
		for i in range(len(self.EMICOMSTR)):
			if i % 2 == 0:
				color='#ffffff'
			else:
				color='#cccccc'
			s=str("<tr bgcolor='"+color+"'><td>"+str(i)+"</td><td>"+self.EMICOMSTR[i]+"</td><td>"+self.EMICOMDES[i]+"</td></tr>")
			FILE.write(s)
		FILE.write("</table>")
		FILE.write("<br>")
		FILE.write("</body></html>")
		FILE.close()
		self.EMICOM[21]("EMICOM.html as been created to emi directory \n This is useful for understanding EMI COMMAND LIST!")
	def openFile(self=None,event=None):
		print "File Open"
	def saveFile(self=None,event=None):
		print "File Save"
	def saveFileAs(self=None,event=None):
		print "File Save as"
	def setAudioDev(self=None,event=None):
		print "Setup Audio Devices"
	def setDir(self=None,event=None):
		print "Setup Directory"
	def setDir(self=None,event=None):
		print "Setup Directory"
	def setTool(self=None,event=None):
		print "Setup Tool"
	def aboutHelp(self=None,event=None):
		self.EMICOM[21]("emi-ecasound mastering interface (C) 2003-2004 Felix Le Blanc\necasound (C) 1997-2003 Kai Vehmanen\n")
	def emiHelp(self=None,event=None):
		self.EMICOM[21]("PLEASE READ THE ECASOUND DOCUMENTATION")
	def wwwHelp(self=None,event=None):
		self.EMICOM[21]("EMI HOME PAGE\nhttp://emi.thevtek.com\n\nECASOUND HOME PAGE\nhttp://www.wakkanet.fi/~kaiv/ecasound/")
	def toStart(self=None,event=None):
		print "TO START"
	def rew(self=None,event=None):
		print "REW"
	def play(self=None,event=None):
		print "PLAY"
	def stop(self=None,event=None):
		print "STOP"
	def pause(self=None,event=None):
		print "PAUSE"
	def ff(self=None,event=None):
		print "FF"

if __name__=="__main__":
	
	MAIN=Tk()
	w, h = MAIN.winfo_screenwidth(), MAIN.winfo_screenheight()
	MAIN.geometry("%dx%d+0+0" % (w, h))
	MAIN.configure(bg="#000000")
	emi = EMI(MAIN,ww=w)
	def meurt(self=None,event=None):
		emi.EMICOM[21]("EXIT CALLBACK")
		emi.after(2000,emi.EMICOM[17])
	MAIN.bind('q',meurt)
	MAIN.protocol("WM_DELETE_WINDOW", meurt)
	MAIN.mainloop()
